/*
 *  Copyright (c) 2021 NetApp
 *  All rights reserved
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	scheme "quark.netapp.io/volume-controller/pkg/client/clientset/versioned/scheme"
)

// NetAppVolumeSnapshotsListsGetter has a method to return a NetAppVolumeSnapshotsListInterface.
// A group's client should implement this interface.
type NetAppVolumeSnapshotsListsGetter interface {
	NetAppVolumeSnapshotsLists(namespace string) NetAppVolumeSnapshotsListInterface
}

// NetAppVolumeSnapshotsListInterface has methods to work with NetAppVolumeSnapshotsList resources.
type NetAppVolumeSnapshotsListInterface interface {
	Create(ctx context.Context, netAppVolumeSnapshotsList *v1alpha1.NetAppVolumeSnapshotsList, opts v1.CreateOptions) (*v1alpha1.NetAppVolumeSnapshotsList, error)
	Update(ctx context.Context, netAppVolumeSnapshotsList *v1alpha1.NetAppVolumeSnapshotsList, opts v1.UpdateOptions) (*v1alpha1.NetAppVolumeSnapshotsList, error)
	UpdateStatus(ctx context.Context, netAppVolumeSnapshotsList *v1alpha1.NetAppVolumeSnapshotsList, opts v1.UpdateOptions) (*v1alpha1.NetAppVolumeSnapshotsList, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NetAppVolumeSnapshotsList, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NetAppVolumeSnapshotsListList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppVolumeSnapshotsList, err error)
	NetAppVolumeSnapshotsListExpansion
}

// netAppVolumeSnapshotsLists implements NetAppVolumeSnapshotsListInterface
type netAppVolumeSnapshotsLists struct {
	client rest.Interface
	ns     string
}

// newNetAppVolumeSnapshotsLists returns a NetAppVolumeSnapshotsLists
func newNetAppVolumeSnapshotsLists(c *QuarkV1alpha1Client, namespace string) *netAppVolumeSnapshotsLists {
	return &netAppVolumeSnapshotsLists{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the netAppVolumeSnapshotsList, and returns the corresponding netAppVolumeSnapshotsList object, and an error if there is any.
func (c *netAppVolumeSnapshotsLists) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NetAppVolumeSnapshotsList, err error) {
	result = &v1alpha1.NetAppVolumeSnapshotsList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of NetAppVolumeSnapshotsLists that match those selectors.
func (c *netAppVolumeSnapshotsLists) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NetAppVolumeSnapshotsListList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.NetAppVolumeSnapshotsListList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested netAppVolumeSnapshotsLists.
func (c *netAppVolumeSnapshotsLists) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a netAppVolumeSnapshotsList and creates it.  Returns the server's representation of the netAppVolumeSnapshotsList, and an error, if there is any.
func (c *netAppVolumeSnapshotsLists) Create(ctx context.Context, netAppVolumeSnapshotsList *v1alpha1.NetAppVolumeSnapshotsList, opts v1.CreateOptions) (result *v1alpha1.NetAppVolumeSnapshotsList, err error) {
	result = &v1alpha1.NetAppVolumeSnapshotsList{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppVolumeSnapshotsList).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a netAppVolumeSnapshotsList and updates it. Returns the server's representation of the netAppVolumeSnapshotsList, and an error, if there is any.
func (c *netAppVolumeSnapshotsLists) Update(ctx context.Context, netAppVolumeSnapshotsList *v1alpha1.NetAppVolumeSnapshotsList, opts v1.UpdateOptions) (result *v1alpha1.NetAppVolumeSnapshotsList, err error) {
	result = &v1alpha1.NetAppVolumeSnapshotsList{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		Name(netAppVolumeSnapshotsList.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppVolumeSnapshotsList).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *netAppVolumeSnapshotsLists) UpdateStatus(ctx context.Context, netAppVolumeSnapshotsList *v1alpha1.NetAppVolumeSnapshotsList, opts v1.UpdateOptions) (result *v1alpha1.NetAppVolumeSnapshotsList, err error) {
	result = &v1alpha1.NetAppVolumeSnapshotsList{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		Name(netAppVolumeSnapshotsList.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppVolumeSnapshotsList).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the netAppVolumeSnapshotsList and deletes it. Returns an error if one occurs.
func (c *netAppVolumeSnapshotsLists) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *netAppVolumeSnapshotsLists) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched netAppVolumeSnapshotsList.
func (c *netAppVolumeSnapshotsLists) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppVolumeSnapshotsList, err error) {
	result = &v1alpha1.NetAppVolumeSnapshotsList{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("netappvolumesnapshotslists").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
