/*
 *  Copyright (c) 2021 NetApp
 *  All rights reserved
 */

// Code generated by informer-gen. DO NOT EDIT.

package externalversions

import (
	"fmt"

	schema "k8s.io/apimachinery/pkg/runtime/schema"
	cache "k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// GenericInformer is type of SharedIndexInformer which will locate and delegate to other
// sharedInformers based on type
type GenericInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() cache.GenericLister
}

type genericInformer struct {
	informer cache.SharedIndexInformer
	resource schema.GroupResource
}

// Informer returns the SharedIndexInformer.
func (f *genericInformer) Informer() cache.SharedIndexInformer {
	return f.informer
}

// Lister returns the GenericLister.
func (f *genericInformer) Lister() cache.GenericLister {
	return cache.NewGenericLister(f.Informer().GetIndexer(), f.resource)
}

// ForResource gives generic access to a shared informer of the matching type
// TODO extend this to unknown resources with a client pool
func (f *sharedInformerFactory) ForResource(resource schema.GroupVersionResource) (GenericInformer, error) {
	switch resource {
	// Group=quark.netapp.io, Version=v1alpha1
	case v1alpha1.SchemeGroupVersion.WithResource("netappexportpolicies"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NetAppExportPolicies().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("netappservicelevels"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NetAppServiceLevels().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("netappsnapshotpolicies"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NetAppSnapshotPolicies().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("netappvolumes"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NetAppVolumes().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("netappvolumecloudsnapshots"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NetAppVolumeCloudSnapshots().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("netappvolumesnapshots"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NetAppVolumeSnapshots().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("netappvolumesnapshotslists"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NetAppVolumeSnapshotsLists().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("netappvolumeusages"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NetAppVolumeUsages().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("nodevolsets"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().NodevolSets().Informer()}, nil
	case v1alpha1.SchemeGroupVersion.WithResource("quarks"):
		return &genericInformer{resource: resource.GroupResource(), informer: f.Quark().V1alpha1().Quarks().Informer()}, nil

	}

	return nil, fmt.Errorf("no informer found for %v", resource)
}
