/*
 *  Copyright (c) 2021 NetApp
 *  All rights reserved
 */

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
	volumecontrollerv1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	versioned "quark.netapp.io/volume-controller/pkg/client/clientset/versioned"
	internalinterfaces "quark.netapp.io/volume-controller/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/client/listers/volumecontroller/v1alpha1"
)

// NetAppVolumeUsageInformer provides access to a shared informer and lister for
// NetAppVolumeUsages.
type NetAppVolumeUsageInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.NetAppVolumeUsageLister
}

type netAppVolumeUsageInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewNetAppVolumeUsageInformer constructs a new informer for NetAppVolumeUsage type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewNetAppVolumeUsageInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredNetAppVolumeUsageInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredNetAppVolumeUsageInformer constructs a new informer for NetAppVolumeUsage type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredNetAppVolumeUsageInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.QuarkV1alpha1().NetAppVolumeUsages(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.QuarkV1alpha1().NetAppVolumeUsages(namespace).Watch(context.TODO(), options)
			},
		},
		&volumecontrollerv1alpha1.NetAppVolumeUsage{},
		resyncPeriod,
		indexers,
	)
}

func (f *netAppVolumeUsageInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredNetAppVolumeUsageInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *netAppVolumeUsageInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&volumecontrollerv1alpha1.NetAppVolumeUsage{}, f.defaultInformer)
}

func (f *netAppVolumeUsageInformer) Lister() v1alpha1.NetAppVolumeUsageLister {
	return v1alpha1.NewNetAppVolumeUsageLister(f.Informer().GetIndexer())
}
